; ******************************************************************************
;      GetDateTime Ver. 2.55
;      tE֌W̖߂񋟂 HSP 2.55 ȍ~pW[
;      Copyright (c) 2001 Tatsuya Arai
; ******************************************************************************


#module

; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   check_leapyear p1
;       w肳ꂽN[Nǂ𔻒肷B
;         p1 = 0, 1583 ` : 肵Nil^B0 w肵ꍇ݂͌̔NB
;                           1583 NO͔łȂj
;       -----------------------------------------------------------------
;       茋ʂ̓VXeϐ stat ɑB
;       stat ̒lF
;           0 = [Nł͂Ȃ
;           1 = [N
;           2 = s\
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc check_leapyear int
	mref res_lp, 64		; ߂listatj
	mref ly_year, 0		; 肷N
	
	if ly_year = 0 {		; N 0 w肳ꂽ
		gettime ly_year, 0	; ݂̔N擾
	}
	
	if ly_year < 1583 {	; 1583 NOw肳ꂽ
		res_lp = 2		; stat = 2 iłȂj
		return
	}
	
*leapyear
	if (ly_year \ 400) = 0 {	; N 400 Ŋ؂Ȃ
		res_lp = 1				; [N
		return
	}
	
	if (ly_year \ 100) = 0 {	; N 100 Ŋ؂Ȃ
		res_lp = 0				; [Nł͂Ȃ
		return
	}
	
	if (ly_year \ 4) = 0 {		; N 4 Ŋ؂Ȃ
		res_lp = 1				; [N
		return
	}
	
	res_lp = 0		; ȊOȂ[Nł͂Ȃ
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_lastday p1, p2, p3
;       w肳ꂽN܂ł邩擾B
;         p1 = ϐ     : ʂۑ鐔l^ϐB
;         p2 = 0, 1583 ` : 肵Nil^B0 w肵ꍇ݂͌̔NB
;                           1583 NO͔łȂj
;         p3 = 0 ` 12    : 肵il^B0 w肵ꍇ݂͌̌j
;       -----------------------------------------------------------------
;       1583 NO̓tAsȓtiF2001/15jw肵ꍇ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_lastday val, int, int
	mref res_ld, 16		; ߂l
	mref ld_year, 1		; 肷N
	mref ld_month, 2	; 肷錎
	
	if ld_year = 0 {		; N 0 w肳ꂽ
		gettime ld_year, 0	; ݂̔N擾
	}
	
	if ld_month = 0 {		;  0 w肳ꂽ
		gettime ld_month, 1	; ݂̌擾
	}
	
	if (ld_year < 1583) or (ld_month < 1) or (ld_month > 12) {
		res_ld = -1	; 1583 NO̓tsȓt
		return		; w肳ꂽꍇ́A-1 ԂB
	}
	
	if ld_month = 2 {		; 2 ̏ꍇ
		ly_year = ld_year
		gosub *leapyear		; [Ñ`FbNA
		if res_lp = 0 {		; [NłȂȂ
			res_ld = 28		; 28 Ԃ
		}
		else {				; [NȂ
			res_ld = 29		; 29 Ԃ
		}
		return
	}
	
	if ld_month < 8 {			;  8 O
		if (ld_month \ 2) = 0 {	; Ȃ
			res_ld = 30			; 30 Ԃ
		}
		else {					; Ȃ
			res_ld = 31			; 31 Ԃ
		}
		return
	}
	
	if (ld_month \ 2) = 0 {	; 8 ȍ~ŋȂ
		res_ld = 31			; 31 Ԃ
	}
	else {					; Ȃ
		res_ld = 30			; 30 Ԃ
	}
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   check_datevalidity p1, p2, p3
;     t̎wɖ肪Ȃ`FbNB
;         p1 = 1583 ` 3999 : 肵Nil^B1583 NO^3999 N͔łȂj
;         p2 = 1 ` 12      : 肵il^j
;         p3 = 1 ` 31      : 肵il^j
;       -----------------------------------------------------------------
;       茋ʂ̓VXeϐ stat ɑB
;       tɖȂ 0AsȓtȂ -1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc check_datevalidity int, int, int
	mref res_dv, 64		; ߂listatj
	mref dv_year, 0		; 肷N
	mref dv_month, 1	; 肷錎
	mref dv_day, 2		; 肷
	
*datevalidity
	res_dv = 0		; Ȃ 0 Ԃ
	
	if (dv_year < 1583) or (dv_year > 3999) {
		res_dv = -1	; 1583 NO 3999 NȂ -1 Ԃ
	}
	
	if (dv_month < 1) or (dv_month > 12) {
		res_dv = -1	;  1 ` 12 ̊ԂɂȂ -1 Ԃ
	}
	
	get_lastday tmp_d, dv_year, dv_month
	if (tmp_d = -1) {
		res_dv = -1
	}
	
	if (dv_day < 1) or (dv_day > tmp_d) {
		res_dv = -1	;  1 `̊ԂɂȂ -1 Ԃ
	}
	return




; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   check_timevalidity p1, p2, p3, p4
;     ̎wɖ肪Ȃ`FbNB
;         p1 = 0 ` 23 : 肵il^j
;         p2 = 0 ` 59 : 肵il^j
;         p3 = 0 ` 59 : 肵bil^j
;         p4 = 0 `  2 : Ԃ̌`i0 = 24 ԐA1 = ߑOA2 = ߌj
;       -----------------------------------------------------------------
;       茋ʂ̓VXeϐ stat ɑB
;       ɖȂ 0AsȎȂ -1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc check_timevalidity int, int, int, int
	mref res_tv, 64		; ߂listatj
	mref tv_hour, 0		; 肷鎞
	mref tv_minute, 1	; 肷镪
	mref tv_second, 2	; 肷b
	mref tv_type, 3		; Ԃ̌`i0 = 24 ԐA1 = ߑOA2 = ߌj
	
*timevalidity
	res_tv = 0	; Ȃ 0 Ԃ
	
	if (tv_type = 1) and (tv_hour > 12) {	; uߑOvw肳Ă
		res_tv = -1							;  12 傫
		return								; -1 Ԃ
	}
	
	if tv_type = 2 {				; uߌvw肳Ă
		tv_hour = tv_hour + 12		; 12 ԕvXi= 24 Ԑɕςj
		if tv_hour = 24 {			; 24 
			tv_hour = 12			; 12 ɂ
		}
	}
	
	if (tv_hour < 0) or (tv_hour > 23) or (tv_minute < 0) or (tv_minute > 59) or (tv_second < 0) or (tv_second > 59) {
		res_tv = -1		; ɖ肪 -1 Ԃ
	}
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_julius p1, p2, p3, p4
;       w肳ꂽt̃EX擾B
;         p1 = ϐ          : ʂۑ鐔l^ϐB
;         p2 = 0, 1583 ` 3999 : 擾Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p3 = 0 ` 12         : 擾il^B0 w肵ꍇ݂͌̌j
;         p4 = 0 ` 31         : 擾il^B0 w肵ꍇ݂͌̓j
;       -----------------------------------------------------------------
;       1583 NO^3999 N̓tAsȓtiF2001/15/-20j
;       w肵ꍇ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_julius val, int, int, int
	mref res_jd, 16		; ߂l
	mref jd_year, 1		; 肷N
	mref jd_month, 2	; 肷錎
	mref jd_day, 3		; 肷
	
	if jd_year = 0 {		; N 0 w肳ꂽ
		gettime jd_year, 0	; ݂̔N擾
	}
	if jd_month = 0 {		;  0 w肳ꂽ
		gettime jd_month, 1	; ݂̌擾
	}
	if jd_day = 0 {			;  0 w肳ꂽ
		gettime jd_day, 3	; ݂̓擾
	}
	
	dv_year = jd_year
	dv_month = jd_month
	dv_day = jd_day
	gosub *datevalidity
	
	if res_dv = -1 {	; sȓtw肳ꂽ
		res_jd = -1		; -1 Ԃ
		return
	}
	
; ----- EXZo ------------------------------------------
	if jd_month <= 2 {				; t 1  2 
		jd_month = jd_month + 12	; ON 13 ܂ 14 ƂČvZ
		jd_year = jd_year - 1
	}
	
	jd_y1 = jd_year / 100
	jd_y2 = jd_year - (jd_y1 * 100)
	
	res_jd = (3652425 * jd_y1 / 100) + (36525 * jd_y2 / 100) + (306 * (jd_month + 1) / 10) + jd_day + 1720997
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_juliustoymd p1, p2
;       w肳ꂽEXOSI̓tŎ擾B
;         p1 = ϐ     : tۑzϐiꎟAl^Bvf = 3B
;                           ip1.0 = NAp1.1 = Ap1.2 = j
;         p2 = 2299239 ` : ϊEXil^j
;       -----------------------------------------------------------------
;       EX 2299239iOSI 1583 N 1  1 jw肵Ƃ́A
;       p1 Ŏw肵zϐ̗vf 0 ` 2  -1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_juliustoymd val, int
	mref res_jy, 48		; ߂livf 3 ̐l^ꎟzϐj
	mref jy_julday, 1	; ϊbil^j
	
	if jy_julday < 2299239 {	; EX 2299239 w肳ꂽꍇ
		res_sh = -1, -1, -1		; -1 Ԃ
		return
	}
	
; ----- EXOSI̓tZo --------------------
	a0 = (jy_julday - 1721120) / 146097
	b0 = (jy_julday - 1721120) \ 146097
	a1 = b0 / 36524
	b1 = b0 \ 36524
	a2 = b1 / 1461
	b2 = b1 \ 1461
	a3 = b2 / 365
	b3 = b2 \ 365
	a4 = b3 / 153
	b4 = b3 \ 153
	a5 = b4 / 61
	b5 = b4 \ 61
	a6 = b5 / 31
	b6 = b5 \ 31
	
	res_jy.0 = (400 * a0) + (100 * a1) + (4 * a2) + a3
	res_jy.1 = (5 * a4) + (2  * a5) + a6 + 3
	res_jy.2 = b6 + 1
	
	If (res_jy.1 = 13) Or (res_jy.1 = 14) {	; vZʂ 13  14 
		res_jy.1 = res_jy.1 - 12	; N 1  ܂ 2 ɂ
		res_jy.0 = res_jy.0 + 1
	}
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_dateinterval p1, p2, p3, p4, p5, p6, p7
;       w肳ꂽ̓t̊Ԋu擾B
;         p1 = ϐ          : ʂۑ鐔l^ϐB
;         p2 = 0, 1583 ` 3999 : 肵ڂ̓t̔Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p3 = 0 ` 12         : 肵ڂ̓ťil^B0 w肵ꍇ݂͌̌j
;         p4 = 0 ` 31         : 肵ڂ̓t̓il^B0 w肵ꍇ݂͌̓j
;         p5 = 0, 1583 ` 3999 : 肵ڂ̓t̔Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p6 = 0 ` 12         : 肵ڂ̓ťil^B0 w肵ꍇ݂͌̌j
;         p7 = 0 ` 31         : 肵ڂ̓t̓il^B0 w肵ꍇ݂͌̓j
;       -----------------------------------------------------------------
;       1583 NO^3999 N̓tAsȓtiF2001/15/-20j
;       w肵ꍇ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_dateinterval val, int, int, int, int, int, int
	mref res_di, 16		; ߂l
	mref di_year1, 1	; 肷ڂ̓t̔N
	mref di_month1, 2	; 肷ڂ̓ť
	mref di_day1, 3		; 肷ڂ̓t̓
	mref di_year2, 4	; 肷ڂ̓t̔N
	mref di_month2, 5	; 肷ڂ̓ť
	mref di_day2, 6		; 肷ڂ̓t̓
	
	d1 = 0
	d2 = 0
	
	get_julius d1, di_year1, di_month1, di_day1		; ڂ̓t̃EX߂
	get_julius d2, di_year2, di_month2, di_day2		; ڂ̓t̃EX߂
	
	if (d1 = -1) or (d2 = -1) {		; ǂ炩̃EX -1 isȓtw肵j
		res_di = -1					; -1 Ԃ
		return
	}
	
	res_di = d1 - d2		; ̓t̍߂
	if res_di < 0 {			; }CiXl
		res_di = -res_di	; vXɂiΒl擾j
	}
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_dayofyear p1, p2, p3, p4
;       w肳ꂽt 1  1 琔ĉڂ擾
;         p1 = ϐ          : ʂۑ鐔l^ϐB
;         p2 = 0, 1583 ` 3999 : 擾Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p3 = 0 ` 12         : 擾il^B0 w肵ꍇ݂͌̌j
;         p4 = 0 ` 31         : 擾il^B0 w肵ꍇ݂͌̓j
;       -----------------------------------------------------------------
;       1583 NO^3999 N̓tAsȓtiF2001/15/-20j
;       w肵ꍇ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_dayofyear val, int, int, int
	mref res_dy, 16		; ߂l
	mref dy_year, 1		; 肷N
	mref dy_month, 2	; 肷錎
	mref dy_day, 3		; 肷
	
; ----- w肳ꂽt 1  1 琔ĉڂ擾 --------------
	get_dateinterval res_dy, dy_year, dy_month, dy_day, dy_year, 1, 1
	
	if res_dy ! -1 {			; w 1  1 ̊Ԋu擾ł
		res_dy = res_dy + 1		; (Ԋu + 1 ) Ԃ
	}
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_dayofweek p1, p2, p3, p4
;       w肳ꂽt̗j擾B
;         p1 = ϐ          : ʂۑ鐔l^ϐB
;         p2 = 0, 1583 ` 3999 : 擾Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p3 = 0 ` 12         : 擾il^B0 w肵ꍇ݂͌̌j
;         p4 = 0 ` 31         : 擾il^B0 w肵ꍇ݂͌̓j
;       -----------------------------------------------------------------
;       p1 Ŏw肳ꂽϐɑl͈ȉ̂悤ɂȂĂB

;       -1 : 擾łȂ    3 : j
;        0 : j          4 : ؗj
;        1 : j          5 : j
;        2 : Ηj          6 : yj

;       1583 NO^3999 N̓tAsȓtiF2001/15/-20j
;       w肵ꍇ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_dayofweek val, int, int, int
	mref res_dw, 16		; ߂l
	mref dw_year, 1		; 肷N
	mref dw_month, 2	; 肷錎
	mref dw_day, 3		; 肷
	
	if dw_year = 0 {		; N 0 w肳ꂽ
		gettime dw_year, 0	; ݂̔N擾
	}
	if dw_month = 0 {		;  0 w肳ꂽ
		gettime dw_month, 1	; ݂̌擾
	}
	if dw_day = 0 {			;  0 w肳ꂽ
		gettime dw_day, 3	; ݂̓擾
	}
	
*dayofyear
	dv_year = dw_year
	dv_month = dw_month
	dv_day = dw_day
	gosub *datevalidity
	
	if res_dv = -1 {	; sȓtw肳ꂽ
		res_dw = -1		; -1 Ԃ
		return
	}
	
; ----- Zeller ̌pėjZo ---------------------------
	if dw_month <= 2 {				; 1 A2 ̏ꍇ
		dw_year = dw_year - 1		; ON
		dw_month = dw_month + 12	; 13 A14 ƂČvZ
	}
	
	res_dw = (dw_year + (dw_year / 4) - (dw_year / 100) + (dw_year / 400) + ((26 * dw_month + 16) / 10) + dw_day) \ 7
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_vernal p1, p2
;       w肳ꂽN̏t擾
;         p1 = ϐ          : tۑ鐔l^ϐi 3 jB
;         p2 = 0, 1900 ` 2099 : t擾Nil^B0 w肵ꍇ݂͌̔NB
;                                1900 NO^2099 N͎擾łȂj
;       -----------------------------------------------------------------
;       p1 ɕԂ͓̂̂݁i͕K 3 ɂȂ̂Łj
;       1900 NO^2099 N̔Nw肵ꍇ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_vernal val, int
	mref res_vd, 16		; ߂l
	mref vd_year, 1		; 肷N
	
	if vd_year = 0 {		; N 0 w肳ꂽ
		gettime vd_year, 0	; ݂̔N擾
	}
	
	if (vd_year < 1900) or (vd_year > 2099) {	; N 1900 ` 2099 ͈̔͊OȂ
		res_vd = -1								; -1 ԂB
		return
	}
	
	res_vd = (24242 * vd_year - (vd_year / 4 * 100000) + 3584000) / 100000
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_autumnal p1, p2
;       w肳ꂽN̏H擾
;         p1 = ϐ          : Hۑ鐔l^ϐi 9 jB
;         p2 = 0, 1900 ` 2099 : H擾Nil^B0 w肵ꍇ݂͌̔NB
;                                1900 NO^2099 N͎擾łȂj
;       -----------------------------------------------------------------
;       p1 ɕԂ͓̂̂݁i͕K 9 ɂȂ̂Łj
;       1900 NO^2099 N̔Nw肵ꍇ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_autumnal val, int
	mref res_ad, 16		; ߂l
	mref ad_year, 1		; 肷N
	
	if ad_year = 0 {		; N 0 w肳ꂽ
		gettime ad_year, 0	; ݂̔N擾
	}
	
	if (ad_year < 1900) or (ad_year > 2099) {	; N 1900 ` 2099 ͈̔͊OȂ
		res_ad = -1								; -1 ԂB
		return
	}
	
	res_ad = (24204 * ad_year - (ad_year / 4 * 100000) + 3901000) / 100000
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_calcdate p1, p2, p3, p4, p5, p6, p7
;       w肵t́O^̓t擾B
;         p1 = ϐ          : tۑzϐiꎟAl^Bvf = 3B
;                                ip1.0 = NAp1.1 = Ap1.2 = j
;         p2 = 0, 1583 ` 3999 : w肵Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p3 = 0 ` 12         : w肵il^B0 w肵ꍇ݂͌̌j
;         p4 = 0 ` 31         : w肵il^B0 w肵ꍇ݂͌̓j
;         p5                   : tɑ^il^j
;       -----------------------------------------------------------------
;       1583 NO^3999 N̓tAsȓtiF2001/15/-20j
;       w肵ꍇA܂AvZʂ1583 NO^3999 N̓tɂȂꍇ́A
;       p1 Ŏw肵zϐ̗vf 0 ` 2  -1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_calcdate val, int, int, int, int, int, int
	mref res_cd, 16		; ߂l
	mref cd_year, 1		; w肷N
	mref cd_month, 2	; w肷錎
	mref cd_day, 3		; w肷
	mref cd_num, 4		; tɑ^
	
	get_julius jd, cd_year, cd_month, cd_day
	
	if jd = -1 {			; tɖ肪Lꍇ
		res_cd = -1, -1, -1	; -1 Ԃ
		return
	}
	
	jd = jd + cd_num			; w肳ꂽ
	get_juliustoymd res_cd, jd	; t擾
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   make_calendar p1, p2, p3
;       w肵ꎟzɃJ_[쐬B
;         p1 = ϐ          : tۑzϐiꎟAl^Bvf = 37j
;         p2 = 0, 1583 ` 3999 : w肵Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p3 = 0 ` 12         : w肵il^B0 w肵ꍇ݂͌̌j
;       -----------------------------------------------------------------
;       1583 NO^3999 N̓tAsȓtiF2001/-15j
;       w肵ꍇ́Ap1 Ŏw肵zϐ̗vf 0 ` 36  -1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc make_calendar val, int, int
	mref res_mc, 48		; ߂l
	mref mc_year, 1		; w肷N
	mref mc_month, 2	; w肷錎
	
	mc_d = 1	;  1 
	
	repeat 37
		res_mc.cnt = -1		; zׂĂ -1 Ŗ߂
	loop
	
	if mc_year = 0 {			; N 0 w肳ꂽꍇ
		gettime mc_year, 0		; ݂̔N擾
	}
	if mc_month = 0 {			;  0 w肳ꂽꍇ
		gettime mc_month, 1		; ݂̌擾
	}
	
	get_lastday mc_lastday, mc_year, mc_month				; w肳ꂽN̓擾
	get_dayofweek mc_dayofweek, mc_year, mc_month, mc_d		; w肳ꂽN 1 ̗j擾
	
	if (mc_lastday = -1) or (mc_dayofweek = -1) {	; sȔNw肳ꂽꍇ
		return										; W[𔲂
	}
	
	repeat mc_lastday, mc_dayofweek	; JԂ
		res_mc.cnt = mc_d			; zɓ
		mc_d = mc_d + 1				;  1 ₷
	loop
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   make_calendar2 p1, p2, p3
;       w肵񎟌zɃJ_[쐬B
;         p1 = ϐ          : tۑzϐi񎟌Al^Bvf = 6 * 7j
;         p2 = 0, 1583 ` 3999 : w肵Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p3 = 0 ` 12         : w肵il^B0 w肵ꍇ݂͌̌j
;       -----------------------------------------------------------------
;       1583 NO^3999 N̓tAsȓtiF2001/-15j
;       w肵ꍇ́Ap1 Ŏw肵zϐ̗vf 0.0 ` 5.6  -1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc make_calendar2 val, int, int
	mref res_mc2, 48	; ߂l
	mref mc2_year, 1	; w肷N
	mref mc2_month, 2	; w肷錎
	
	repeat 6
		tmpcnt = cnt
		repeat 7
			res_mc2.tmpcnt.cnt = -1	; zׂĂ -1 Ŗ߂
		loop
	loop
	
	if mc2_year = 0 {			; N 0 w肳ꂽꍇ
		gettime mc2_year, 0		; ݂̔N擾
	}
	if mc2_month = 0 {			;  0 w肳ꂽꍇ
		gettime mc2_month, 1		; ݂̌擾
	}
	
	get_lastday mc2_lastday, mc2_year, mc2_month		; w肳ꂽN̓擾
	get_dayofweek mc2_dayofweek, mc2_year, mc2_month, 1	; w肳ꂽN 1 ̗j擾
	
	if (mc2_lastday = -1) or (mc2_dayofweek = -1) {	; sȔNw肳ꂽꍇ
		return										; W[𔲂
	}
	
	dim mc2tmp, 37
	make_calendar mc2tmp, mc2_year, mc2_month	; ꎞIɈꎟzɃJ_[쐬
	
	mc2tmp2 = 0
	
; ----- make_calendar ō쐬ꎟz̓eA񎟌zɈڂ -----------
	repeat 6
		tmpcnt = cnt
		repeat 7
			if mc2tmp2 < 37 {
				res_mc2.tmpcnt.cnt = mc2tmp.mc2tmp2
				mc2tmp2 = mc2tmp2 + 1
			}
			else {
				res_mc2.tmpcnt.cnt = -1
			}
		loop
	loop
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_datetime p1, p2, p3, p4
;       ݂̓tƎ擾Aw肳ꂽɂĕԂB
;         p1 = ϐ   : ݂̓tƎi[镶^ϐ
;         p2 = -1 ` 15 : t̏il^B-1 ̏ꍇ͓tԂȂj
;         p3 = -1 `  7 : ̏il^B-1 ̏ꍇ͎ԂȂj
;         p4 =  0 ` 10 : tƎ̊Ԃɓ󔒂̐
;                        il^Bp2Ap3 0 ȏ̎̂ݗLj
;       -----------------------------------------------------------------
;       p2, p3 ̎wɌ肪ꍇ "" ԂB

;       p2                          \
;        0  yy/MM/dd                    01/01/05
;        1  yy/M/d                      01/1/5
;        2  yyyy/MM/dd                  2001/01/05
;        3  yyyy/M/d                    2001/1/5
;        4  yy/MM/dd' ('ddd')'          01/01/05 ()
;        5  yy/M/d' ('ddd')'            01/1/5 ()
;        6  yyyy/MM/dd' ('ddd')'        2001/01/05 ()
;        7  yyyy/M/d' ('ddd')'          2001/1/5 ()
;        8  yy'N'MM''dd''          01N0105
;        9  yy'N'M''d''            01N15
;       10  yyyy'N'MM''dd''        2001N0105
;       11  yyyy'N'M''d''          2001N15
;       12  yy'N'MM''dd'' dddd     01N0105 j
;       13  yy'N'M''d'' dddd       01N15 j
;       14  yyyy'N'MM''dd'' dddd   2001N0105 j
;       15  yyyy'N'M''d'' dddd     2001N15 j

;       p3                          \
;        0  hh:mm:ss                    15:07:04
;        1  h:m:s                       15:7:4
;        2  tt hh:mm:ss                 ߌ 03:07:04
;        3  tt h:m:s                    ߌ 3:7:4
;        4  hhmmssb                150704b
;        5  hmsb                   1574b
;        6  tt hhmmssb             ߌ 030704b
;        7  tt hmsb                ߌ 374b
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_datetime val, int, int, int
	mref res_dt, 24		; ߂l
	mref d_type, 1		; t̏̎
	mref t_type, 2		; ̏̎
	mref spc_cnt, 3		; 󔒂̐
	
	res_date = ""		; tij[߂ϐ
	res_time = ""		; ij[߂ϐ
	spc = ""			; tƎ̊Ԃ̋󔒂[߂ϐ
	res_dt = ""			; ߂l[߂ϐ
	
	int d_yy
	int d_mm
	int d_yo
	int d_dd
	int t_hh
	int t_mm
	int t_ss
	
	if (d_type > 15) or (t_type > 7) {	; ̎ނɖ肪
		res_dt = ""						; "" Ԃ
		return
	}
	
	if d_type > -1 {		; get_datetime  p1  0 ȏȂ
		gettime d_yy, 0		; N擾
		gettime d_mm, 1		; 擾
		gettime d_yo, 2		; j擾
		gettime d_dd, 3		; 擾
		gosub *get_date		; tw肳ꂽŎ擾
	}
	
	if t_type > -1 {		; get_datetime  p2  0 ȏȂ
		gettime t_hh, 4		; 擾
		gettime t_mm, 5 	; 擾
		gettime t_ss, 6 	; b擾
		gosub *get_time		; w肳ꂽŎ擾
	}
	
	if (d_type > -1) and (t_type > -1) and (spc_cnt > 0) {
		gosub *set_spc	; tƎ擾ĂāA󔒕 0 ȏȂ󔒂
	}
	
	res_dt = res_date + spc + res_time
	return

; *----------------------------------------------------------------------------*
;      t̎擾
; *----------------------------------------------------------------------------*

*get_date
	sdim youbi, 2, 14	; j̕[߂ϐ
	
	youbi = "", "", "", "", "", "", "y"
	
; -----  0 ߕ\̗L ---------------------------------------
	if (d_type \ 2) = 0 {
		str d_mm, 2		;  0 ߂
		str d_dd, 2
	}
	else {
		str d_mm		;  0 ߂Ȃ
		str d_dd
	}
	
; ----- ̌ ---------------------------------------------------
	if (d_type \ 4) < 2 {
		str d_yy
		strmid d_yy, d_yy, -1, 2	;  2 ɂ
	}
	else {
		str d_yy, 4					;  4 ɂ
	}
	
; ----- iZ^j -------------------------------------------
	if d_type <= 7 {
		res_date = d_yy + "/" + d_mm + "/" + d_dd			; Z`ɂ
	}
	else {
		res_date = d_yy + "N" + d_mm + "" + d_dd + ""	; `ɂ
	}
	
; ----- j̗L ---------------------------------------------------
	if ((d_type \ 8) >= 4) and (d_type <= 7){
		res_date = res_date + " (" + youbi.d_yo + ")"	; Z`ŗjt
	}
	
	if ((d_type \ 8) >= 4) and (d_type > 7){
		res_date = res_date + " " + youbi.d_yo + " j"	; `ŗjt
	}
	return
	
	
; *----------------------------------------------------------------------------*
;      ̎擾
; *----------------------------------------------------------------------------*

*get_time
	res_time = ""
	
; ----- 12^24Ԑ̔ -------------------------------------------
	if (t_type \ 4) >= 2 {		; 12Ԑ̏ꍇ̏
		if t_hh < 12 {			; ߑOȂ
			res_time = "ߑO "	; ̐擪ɁuߑOvt
			if t_hh = 0 {		; 0 Ȃ
				t_hh = 12		; 12 ɂ
			}
		}
		else {					; ߌȂ
			res_time = "ߌ "	; uߌvt
			t_hh = t_hh - 12	; 擾Ԃ12ԕ
			if t_hh = 0 {		; ʂ 0 
				t_hh = 12		; 12 ɂ
			}
		}
	}
	
; -----  0 ߕ\̗L ---------------------------------------
	if (t_type \ 2) = 0 {
		str t_hh, 2		;  0 ߂
		str t_mm, 2
		str t_ss, 2
	}
	else {
		str t_hh		;  0 ߂Ȃ
		str t_mm
		str t_ss
	}
	
; ----- iZ^j -------------------------------------------
	if t_type <= 3 {
		res_time = res_time + t_hh + ":" + t_mm + ":" + t_ss			; Z`ɂ
	}
	else {
		res_time = res_time + t_hh + "" + t_mm + "" + t_ss + "b"	; `ɂ
	}
	return


; *----------------------------------------------------------------------------*
;      󔒂̍쐬
; *----------------------------------------------------------------------------*

*set_spc
	if spc_cnt > 10 {	; 󔒂̌10ȏɎw肳Ă
		spc_cnt = 10	; 10ɂ
	}
	
	repeat spc_cnt		; w肳ꂽ
		spc = spc + " "	; 󔒂
	loop
	
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_datestr p1, p2, p3, p4, p5
;       w肳ꂽtAw肳ꂽɂĕԂB
;         p1 = ϐ          : w肳ꂽɂti[镶^ϐ
;         p2 = 0 ` 15         : t̏il^j
;         p3 = 0, 1583 ` 3999 : 擾Nil^B0 w肵ꍇ݂͌̔NB
;                                1583 NO^3999 N͎擾łȂj
;         p4 = 0 ` 12         : 擾il^B0 w肵ꍇ݂͌̌j
;         p5 = 0 ` 31         : 擾il^B0 w肵ꍇ݂͌̓j
;       -----------------------------------------------------------------
;       p2 ̎wɌ肪ꍇA
;       1583 NO^3999 N̓tAsȓtiF2001/15/-20j
;       w肵ꍇ́A"" ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_datestr val, int, int, int, int
	mref res_ds, 24		; ߂l
	mref ds_type, 1		; t̏̎
	mref ds_year, 2		; N
	mref ds_month, 3	; 
	mref ds_day, 4		; 
	
	if (ds_type < 0) or (ds_type > 15) {	; ̎ނɖ肪
		res_ds = ""							; "" Ԃ
		return
	}
	
	if ds_year = 0 {			; N 0 w肳Ă
		gettime ds_year, 0		; ݂̔N擾
	}
	if ds_month = 0 {			;  0 w肳Ă
		gettime ds_month, 1		; ݂̌擾
	}
	if ds_day = 0 {				;  0 w肳Ă
		gettime ds_day, 3		; ݂̓擾
	}
	
	get_dayofweek ds_youbi, ds_year, ds_month, ds_day	; j擾
	if ds_youbi = -1 {	; j擾łȂisȓtjꍇ
		res_ds = ""		; "" Ԃ
		return
	}
	
	res_date = ""
	d_type = ds_type
	d_yy = ds_year
	d_mm = ds_month
	d_dd = ds_day
	d_yo = ds_youbi
	gosub *get_date		; w肳ꂽœt擾
	res_ds = res_date
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_timestr p1, p2, p3, p4, p5
;       w肳ꂽAw肳ꂽɂĕԂB
;         p1 = ϐ   : w肳ꂽɂi[镶^ϐ
;         p2 = 0 ` 7   : ̏il^j
;         p3 = -1 ` 23 : 擾il^B-1 w肵ꍇ݂͌̎j
;         p4 = -1 ` 59 : 擾il^B-1 w肵ꍇ݂͌̕j
;         p5 = -1 ` 59 : 擾bil^B-1 w肵ꍇ݂͌̕bj
;       -----------------------------------------------------------------
;       p2 ̎wɌ肪ꍇAsȎiF25:-20:05j
;       w肵ꍇ́A"" ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_timestr val, int, int, int, int
	mref res_ts, 24		; ߂l
	mref ts_type, 1		; t̏̎
	mref ts_hour, 2		; 
	mref ts_minute, 3	; 
	mref ts_second, 4	; b
	
	if (ts_type < 0) or (ts_type > 7) {		; ̎ނɖ肪
		res_ts = ""							; "" Ԃ
		return
	}
	
	if ts_hour = -1 {			;  0 w肳Ă
		gettime ts_hour, 4		; ݂̎擾
	}
	if ts_minute = -1 {			;  0 w肳Ă
		gettime ts_minute, 5	; ݂̕擾
	}
	if ts_second = -1 {			; b 0 w肳Ă
		gettime ts_second, 6	; ݂̕b擾
	}
	
	res_time = ""
	t_type = ts_type
	t_hh = ts_hour
	t_mm = ts_minute
	t_ss = ts_second
	gosub *get_time		; w肳ꂽŎ擾
	res_ts = res_time
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   getdt_format p1, p2, p3 ,p4
;       get_datetime ΉĂtƎ̏ԂB
;         p1 = ϐ   : tƎ̏i[镶^ϐ
;         p2 = -1 ` 15 : t̏il^B-1 ̏ꍇ͓t̏ԂȂj
;         p3 = -1 `  7 : ̏il^B-1 ̏ꍇ͎̏ԂȂj
;         p4 =  0 ` 10 : tƎ̊Ԃɓ󔒂̐
;                        il^Bp2Ap3 0 ȏ̎̂ݗLj
;       -----------------------------------------------------------------
;       p2, p3 ̏́Aget_datetime ƋʁB
;       p2, p3 ̎wɌ肪ꍇ "" ԂB
;       getdt_format ͏̂܂ܕԂ_ get_datetime Ƃ̈ႢB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc getdt_format val, int, int, int
	mref res_dt, 24		; ߂l
	mref d_type, 1		; t̏̎
	mref t_type, 2		; ̏̎
	mref spc_cnt, 3		; 󔒂̐
	
	res_date = ""		; tij[߂ϐ
	res_time = ""		; ij[߂ϐ
	spc = ""			; tƎ̊Ԃ̋󔒂[߂ϐ
	res_dt = ""			; ߂l[߂ϐ
	
	if d_type > -1 {	; get_datetime  p1  0 ȏȂ
		gosub *d_format	; t擾
	}
	
	if t_type > -1 {	; get_datetime  p2  0 ȏȂ
		gosub *t_format	; 擾
	}
	
	if (d_type > -1) and (t_type > -1) and (spc_cnt > 0) {
		gosub *set_spc	; tƎ擾ĂāA󔒕 0 ȏȂ󔒂
	}
	
	res_dt = res_date + spc + res_time
	return


; *----------------------------------------------------------------------------*
;      t̏̎擾
; *----------------------------------------------------------------------------*

*d_format
	sdim d_tmp, 30, 16
	
	d_tmp.0 = "yy/MM/dd"
	d_tmp.1 = "yy/M/d"
	d_tmp.2 = "yyyy/MM/dd"
	d_tmp.3 = "yyyy/M/d"
	d_tmp.4 = "yy/MM/dd' ('ddd')'"
	d_tmp.5 = "yy/M/d' ('ddd')'"
	d_tmp.6 = "yyyy/MM/dd' ('ddd')'"
	d_tmp.7 = "yyyy/M/d' ('ddd')'"
	d_tmp.8 = "yy'N'MM''dd''"
	d_tmp.9 = "yy'N'M''d''"
	d_tmp.10 = "yyyy'N'MM''dd''"
	d_tmp.11 = "yyyy'N'M''d''"
	d_tmp.12 = "yy'N'MM''dd'' dddd"
	d_tmp.13 = "yy'N'M''d'' dddd"
	d_tmp.14 = "yyyy'N'MM''dd'' dddd"
	d_tmp.15 = "yyyy'N'M''d'' dddd"
	
	res_date = d_tmp.d_type
	return

; *----------------------------------------------------------------------------*
;      ̏̎擾
; *----------------------------------------------------------------------------*

*t_format
	sdim t_tmp, 16, 16
	
	t_tmp.0 = "hh:mm:ss"
	t_tmp.1 = "h:m:s"
	t_tmp.2 = "tt hh:mm:ss"
	t_tmp.3 = "tt h:m:s"
	t_tmp.4 = "hhmmssb"
	t_tmp.5 = "hmsb"
	t_tmp.6 = "tt hhmmssb"
	t_tmp.7 = "tt hmsb"
	
	res_time = t_tmp.t_type
	return
#global



#module

; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_hmstosecond p1, p2, p3, p4
;       w肳ꂽԂbɕϊB
;         p1 = ϐ : ʂۑ鐔l^ϐ
;         p2 = -1 `  : ϊil^B-1 w肵Ƃ݂͌̎j
;         p3 = -1 `  : ϊil^B-1 w肵Ƃ݂͌̕j
;         p4 = -1 `  : ϊbil^B-1 w肵Ƃ݂͌̕bj
;       -----------------------------------------------------------------
;       sȎiF-50:3:20jw肵Ƃ́A-1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_hmstosecond val, int, int, int
	mref res_hs, 16		; ߂l
	mref hs_hour, 1		; 肷鎞
	mref hs_minute, 2	; 肷镪
	mref hs_second, 3	; 肷b
	
	if hs_hour = -1 {			; w肳ĂȂꍇ
		gettime hs_hour, 4		; ݂̎擾
	}
	if hs_minute = -1 {			; w肳ĂȂꍇ
		gettime hs_minute, 5	; ݂̕擾
	}
	if hs_second = -1 {			; bw肳ĂȂꍇ
		gettime hs_second, 6	; ݂̕b擾
	}
	
	if (hs_houe < 0) or (hs_minute < 0) or (hs_second < 0) {
		res_hs = -1		; EEb̂ꂩ 0  -1 Ԃ
		return
	}
	
	res_hs = (hs_hour * 60 * 60) + (hs_minute * 60) + hs_second	; b߂
	return



; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;   get_secondtohms p1, p2
;       w肳ꂽbuFFbv`ɕϊB
;         p1 = ϐ : ʂۑzϐiꎟAl^Bvf = 3B
;                       ip1.0 = Ap1.1 = Ap1.2 = bj
;         p2 = 0 `   : ϊbil^j
;       -----------------------------------------------------------------
;       sȕbiF-5020jw肵Ƃ́Ap1 Ŏw肵zϐ
;       vf 0 ` 2  -1 ԂB
; /*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*

#deffunc get_secondtohms val, int
	mref res_sh, 48		; ߂livf 3 ̐l^ꎟzϐj
	mref sh_second, 1	; ϊbil^j
	
	if sh_second < 0 {			; sȕbw肳ꂽꍇ
		res_sh = -1, -1, -1		; -1 Ԃ
		return
	}
	
	res_sh.0 = sh_second / 3600			; vZ
	res_sh.1 = (sh_second \ 3600) / 60	; vZ
	res_sh.2 = (sh_second \ 3600) \ 60	; bvZ
	return
#global
